Attribute VB_Name = "Mod1"
Option Explicit

'-- MODIFIED SETUP1 PROJECT. See further notes at bottom of this module.
'
' #######################################################

' THIS IS THE noSE VERSION. THIS VERSION OF SETUP1
' DOES NOT REQUIRE A SETUP.EXE FILE. SEE THE HELP
'  (HTML) FILE FOR EXPLANATION.

' #######################################################
'
'-- Note about comments:
'
  '  This is an original comment:  '
  '  This is my own comment:       '--
  '
  '  In general, the variable names that begin with "G" or "M"
  '  are from the original code, and constants like "vbQuestion"
  '  are also from original code. Also, local variables beginning with
  '  "l" (small ell), "str", or "int" are from original code.
  '
  '    When you see variables with data type prepended as single letter, such as
  '  "sSomeString", "LSomeLong", "cSomeConstant" or "CSomeClass" or "AsomeArray",
  '   those are generally mine. Also mine, literals like the 64 in:
  '         Msgbox message, 64, title
  '
  '   Much of the code here is not changed. The basic functions
  '  to copy files, register them, register licenses, get file
  '  version info., etc. are all original, but they may contain bits
  '  of new code. For instance, in order to avoid the removal of files
  '  installed to App. Data during uninstall, code was inserted to
  '  prevent logging of those installs. Another example: ResolveDestDir
  '  in ModInstall is mainly original, but it needed a section added
  '  in the select case in order to process files marked in setup.lst
  '  to go to AppData.
  '
  '     In contrast to the main function code, the forms bear
  '  little resemblance to the original. The outdated fullscreen
  '  blue back form is gone and very little functionality is actually
  '  in the form modules themselves.
'
'_________________________________________________________________

'-- Sub Main loads forms and shows windows. Each form load deals
'-- with its own form back gradient coloring using the ColorBack function
'-- in ModFormOps.
'-- fWelcome is displayed with license. Clicking Continue runs
'-- ShowBeginInstall, which shows frmBegin with tentative App.
'-- Path. Clicking Install on frmBegin runs Proceed Install (below).
'----------------------------------------
Public Sub Main()
  On Error Resume Next
     GetPathStrings '--get paths of system folders and data from Setup.lst
     Load fWelcome
     Load frmPath
     Load frmBegin
                     '--get prog. files folder and make sappfolder path:
     GetProgFolder '--gets Program Files and adds sAppName: C:\Program Files\ABC-Editor\
       
       '--borderize puts a light border around windows.
     Borderize fWelcome.hWnd
       Borderize fWelcome.Frame2.hWnd
     Borderize frmBegin.hWnd
     Borderize frmPath.hWnd
        '-- once Sub Main is done loading forms and finding paths,
        '-- fWelcome is left onscreen to continue:
     fWelcome.Show 0
     Err.Clear
End Sub

  '-- This is the first thing called from Sub Main.
  '-- This sub establishes the various system and app paths needed by setup,
  '-- and it gets the values needed from setup.lst
Public Sub GetPathStrings()
  Dim iRet As Integer
  Dim sRemAppSize As String, sFol As String
     On Error Resume Next
  
  '-- get current directory and build setup.lst path:
  sInstallFilesPath = CurDir$("")  '-- sInstallFilesPath is beginning location of setup files.
   AddSlash sInstallFilesPath
  sLSTFile = sInstallFilesPath & "SETUP.LST"
  
'----------------------------- get setup.lst values -----------------------------------

 '-- get app name, which is used for program folder:
    sAppName = ReadIniFile(sLSTFile, "Setup", "Title")
      If (Len(sAppName) = 0) Then
         MsgBox "Setup cannot continue. No Setup.LST file found.", 64, sSETUP
         ExitSetup GintRET_FATAL
      End If
      
  '-- get app filename, like "ABC-Ed.exe":
    sAppEXEName = ReadIniFile(sLSTFile, "Setup", "AppExe")
    
  '--get a temp folder:
    sTempFol = GetFolderPathWSlash(3)    '-- TEMP folder.
    sTempInstallFol = sTempFol & ReadIniFile(sLSTFile, "Bootstrap", "TmpDir")
     AddSlash sTempInstallFol '-- like: "c:\windows\temp\frkdj.vbw"
     
  '-- build CAB path from install folder plus CAB file name:
    sCABFileName = ReadIniFile(sLSTFile, "Bootstrap", "CabFile")
    sCABPath = sInstallFilesPath & sCABFileName
    
  '-- Three new values in setup.lst, used to update the PDW setup.
     '* sRemIcon: loc. of prog. icon for XP add/remove. (Icon source must be in App.Path folder.)
     '* sRemAppSize: Total app size installed (KB), for XP add/remove window.
     '* sAppDataSubFol: Name of App. Data subfolder if App Data storage is used.
    sRemIcon = ReadIniFile(sLSTFile, "Setup", "AppRemIcon")  '-- setup.lst example: AppRemIcom=program.exe 0
    sRemAppSize = ReadIniFile(sLSTFile, "Setup", "AppSize") '-- setup.lst example: AppSize=2026
      If (Len(sRemAppSize) > 0) And (IsNumeric(sRemAppSize) = True) Then
         LRemAppSize = CLng(sRemAppSize)
      End If
    sAppDataSubFol = ReadIniFile(sLSTFile, "Setup", "AppDataName") '-- setup.lst example: AppDataName=AceSoftware

'----------------------------- end getting setup.lst values -----------------------
   On Error GoTo woops
   
'------------------------- get system folder paths -----------------------------------
     '-- User's App Data folder is included here.
     '-- Full App Data path will be App Data & "\CompanyName" (sAppDataSubFol value from
     '-- Setup.lst "AppDataName value.) To use App Data folder, just switch destination
     '-- in Setup.lst from something like "$(AppPath)" to "$(AppData)"
     
  IsNT = IsWindowsNT()
  sWinFol = GetFolderPathWSlash(0)   '-- windows folder.
  sSysFol = GetFolderPathWSlash(1)    '-- system folder.
  sFontFol = GetFolderPathWSlash(2)    '-- fonts folder
  
  
'-- get desktop folder. if NT then set it to all users desktop.
  sFol = GetFolPath(CSIDL_DESKTOP) '-- Desktop and All Users Desktop (for icon).
    If (DirExists(sFol) = True) Then
      sDesktopFol = sFol
         If (IsNT = True) Then
            sFol = GetFolPath(CSIDL_COMMON_DESKTOPDIRECTORY)
            If DirExists(sFol) = True Then sDesktopFol = sFol
         End If
    End If
    
 '-- get user's app data folder.
 '-- if there is no subfolder name then this will not work.
 '-- it should end up like: C:\windows\application data\CompanyName\
 '-- if app data subfolder name was in setup.lst AppDataName value,
 '-- then sAppDataFol will end up being the full path. Otherwise, sAppDataFol = ""
 '-- While we're at it ..... get the Quick Launch folder path.
  sAppDataFol = ""
  sQLFol = ""
   sFol = GetFolPath(CSIDL_APPDATA)
    If (DirExists(sFol) = True) Then
         AddSlash sFol
         sQLFol = sFol & "Microsoft\Internet Explorer\Quick Launch\"
        If (Len(sAppDataSubFol) > 0) Then
           sAppDataFol = sFol & sAppDataSubFol
        End If
    End If
    
'-- get start menu\programs folder (all users version on NT).
  sFol = GetFolPath(CSIDL_PROGRAMS)
    If (DirExists(sFol) = True) Then
      sStartMenuProgFol = sFol
       If (IsNT = True) Then
         sFol = GetFolPath(CSIDL_COMMON_PROGRAMS)
         If DirExists(sFol) = True Then sStartMenuProgFol = sFol
       End If
    End If
   
 '-- if no write access to system folder then use Windows folder as system folder.
 '-- This was original setup1 code.
    If (InStr(UCase$(sSysFol), UCase$(sWinFol)) <> 1) Then
        If Not TestWriteAccess(sSysFol) Then
            sSysFol = sWinFol
        End If
    End If
     
  '-- call DoBootstrap to take care of jobs that setup.exe would have done.
    DoBootstrap
  Exit Sub
woops:
   iRet = MsgBox("Setup cannot continue. Error: " & Err.Description, 64, sSETUP)
    ExitSetup GintRET_FATAL
End Sub

  '-- New function needed in order to skip using setup.exe.
  '-- creates log file and does a few ops that setup.exe would
  '-- normally take care of.
Private Sub DoBootstrap()
  Dim sLogFil1 As String, sExt1 As String, sLogText As String, sMissingFile As String
  Dim iNumFil As Integer, iRet As Integer
  Dim LRet As Long, hKey As Long, lpDWord As Long
  Dim SA As SECURITY_ATTRIBUTES
  Const cLogFil1 As String = "ST6UNST."
  
     On Error Resume Next
'-- create log file. -----------------------
   For iNumFil = 0 To 100
     sExt1 = Right$(("000" & CStr(iNumFil)), 3)
     sLogFil1 = cLogFil1 & sExt1
     If (FileExists(sInstallFilesPath & sLogFil1) = False) Then
       sAppRemovalLog = sInstallFilesPath & sLogFil1
       sLogText = "%% Uninstall Log File - PLEASE DO NOT MODIFY OR DELETE! %%" & vbCrLf & vbCrLf
       sLogText = sLogText & "CONFIG: Title: " & Chr(34) & sAppName & Chr(34) & vbCrLf & vbCrLf
       jsWriteFile sAppRemovalLog, sLogText
       Exit For
     End If
   Next
       DoEvents  '-- necessary? here to make sure new file is found in next line.
       
    If (FileExists(sAppRemovalLog) = False) Then
       sMissingFile = "Log file"
       GoTo woops
    End If
    
     '-- copy VB6STKIT so that CAB can be unpacked. ---------------------------
       If (FileExists(sInstallFilesPath & "VB6STKIT.DLL") = False) Then
         sMissingFile = "VB6STKIT.DLL"
         GoTo woops
       End If
    If (FileExists(sSysFol & "VB6STKIT.DLL") = False) Then
      jsCopyFile sInstallFilesPath & "VB6STKIT.DLL", sSysFol & "VB6STKIT.DLL"
    End If
       jsDeleteFile sInstallFilesPath & "VB6STKIT.DLL"
       
    
      '-- make sure uninstaller is in windows folder, then assign path
      '-- to variable. (Along with log file path, that's in command line
      '-- that normally comes from setup.exe.)
      
        If (FileExists(sInstallFilesPath & "ST6UNST.EXE") = False) Then
           sMissingFile = "ST6UNST.EXE"
           GoTo woops
        End If
    If (FileExists(sWinFol & "ST6UNST.EXE") = False) Then
       jsCopyFile sInstallFilesPath & "ST6UNST.EXE", sWinFol & "ST6UNST.EXE"
    End If
      jsDeleteFile sInstallFilesPath & "ST6UNST.EXE"
      
      sAppRemovalEXE = sWinFol & "ST6UNST.EXE"
  
  Exit Sub
woops:
    MsgBox "Setup cannot continue. Error. File missing: " & sMissingFile, 64, sSETUP
    ExitSetup GintRET_FATAL
End Sub

  '-- this is the second function called from Sub Main.
  '-- It tries to find the program files folder. If it can't find program files folder
  '-- it asks person installing to choose a path by calling ShowPathForm.
  '-- By the time this function is done app.path is established as sAppFolder.
Public Sub GetProgFolder()
 Dim sErr As String
   On Error Resume Next
     '-- This Registry value seems to be valid on all systems. The Shell functions,
     '-- using SHGetSpecialFolderLocation or the newer SHFolder.dll function, seem to
     '-- fail to get the Program Files folder path on all systems, so that option
     '-- is not even attempted here. If the Registry check fails then ask installing
     '-- person to choose a folder.
     
   sProgFol = RegGetString(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir")
  If (DirExists(sProgFol) = False) Then
    sErr = "Unable to find Program Files folder. Please select a destination for the program folder."
     Do While DirExists(sProgFol) = False
       If MsgBox(sErr, vbOKCancel Or vbQuestion, sSETUP) = vbCancel Then
            ExitSetup GintRET_FATAL
       End If
         PathToGet = "prog"
         ShowPathForm "Select Install Location"
     Loop
   End If
   
   AddSlash sProgFol
   sAppFolder = sProgFol & sAppName
   AddSlash sAppFolder '--now sappfolder is program folder tentative.
    
End Sub

'-- ///////// This is the main function. Once the install button has been clicked
'-- in the opening window (fWelcome) frmBegin is shown and the install folder path
'-- can be changed. This function is called when the Install button is clicked
'-- on frmBegin.

'-- This function includes the calls to nearly all other functions
'-- used for install: checks for drive space, copies and registers files,
'-- creates start menu link
'
Public Sub ProceedInstall()
 Dim LSpace As Long
 Dim sMes As String
 Dim iRet As Integer

  On Error GoTo woops
   LSpace = GetDriveSpace(sAppFolder)
    '-- UNIQUE. This will quit if there are less than 10 MB free. You might want
    '-- to change that number. Since hard disks are so large these days this
    '-- function is outdated in most cases, so it was set to 10 to serve as
    '-- a "just in case" function.
     If (LSpace < 10) Then
        MsgBox "Unable to continue due to insufficient disk space.", 64, sSETUP
        ExitSetup GintRET_FATAL
     End If
      
    ' Starts logging to the setup logfile (will be used for application removal)
    ShowLoggingError DllEnableLogging(sAppRemovalLog), LogErrFatal
    
      '--create program folder:
    If (DirExists(sAppFolder) = False) Then
       MakePath sAppFolder, True
    End If
    
       '-- if App Data subfolder is being used then make sure it exists:
    If (Len(sAppDataFol) > 0) Then
       If DirExists(sAppDataFol) = False Then MakePath sAppDataFol, False
         AddSlash sAppDataFol
    End If
    
    frmBegin.lblBegin.Caption = "Copying files..."
     Screen.MousePointer = 11
    CopySection  '-- copy files listed in [Setup1 Files] section.
     Screen.MousePointer = 0
    frmBegin.lblBegin.Caption = "Registering files..."
    RegisterFiles
    RegisterLicenses
   
      '--********** MAKING LNKs *****************************
    '-- creates start menu link and optional desktop, QL links.
    '-- (parameters are dest. folder, exe name, lnk title)
    '-- For secondary shortcuts, write a second sub or call
    '-- AddShortcuts again. As written, this is designed to
    '-- create a single program icon on the start menu (no program
    '-- folder) plus optional icons on desk and Q.L.
      AddShortcuts sAppFolder, sAppEXEName, sAppName
      
       '--register app path.
      If (Len(sAppEXEName) > 0) Then
          AddPerAppPath sAppEXEName, GsDest.strAppDir
      End If
      
       If fWithinAction() Then
         'By now, all logging actions should have been either aborted or committed.
          sMes = "Setup error: Missing CommitAction or AbortAction."
          MsgBox sMes, 64, sSETUP
          ExitSetup GintRET_FATAL
       End If
     frmBegin.lblBegin.Caption = "Finishing setup..."
     MoveAppRemovalFiles

     ExitSetup GintRET_FINISHEDSUCCESS
     
  Exit Sub
woops:
  Screen.MousePointer = 0
  iRet = MsgBox("Error: " & Err.Description, vbRetryCancel, sSETUP)
   
    Select Case iRet
        Case vbRetry
            Resume
        Case vbCancel
            ExitSetup GintRET_ABORT
            Resume
    End Select
End Sub
 
Public Sub ExitSetup(intExitCode As Integer)
  Const iSUCCESS = 0
    Const iFAIL = 1
    Dim LRet As Long
    Dim sErr As String
    Dim nErrorLevel As Integer
       On Error Resume Next
   
  Select Case intExitCode
    Case GintRET_EXIT    'If user chose an Exit or Cancel button
        LRet = MsgBox("Exit Setup?", 36, sSETUP)
        If LRet = 7 Then Exit Sub
    Case GintRET_ABORT 'If user chose to abort before a pending action
         LRet = MsgBox("Setup is not complete. Quit anyway?", 36, sSETUP)
         If LRet = 7 Then Exit Sub
  End Select
  
    'Abort any pending actions
    Do While fWithinAction()
       ShowLoggingError DllAbortAction(), LogErrFatal
    Loop
   
    Close '--close any open files.
   
    Kill sVerTmpName

 Select Case intExitCode
    Case GintRET_EXIT, GintRET_ABORT
       MsgBox "Setup cancelled.", 64, sSETUP
    Case GintRET_FATAL
       MsgBox "Setup was not successfully completed.", 64, sSETUP
    Case GintRET_FINISHEDSUCCESS
       MsgBox "Blah Program setup complete.", 64, sSETUP  '--UNIQUE
   Case Else
       MsgBox "Setup was not successfully completed.", 64, sSETUP
 End Select

    'Stop logging
   ShowLoggingError DllDisableLogging(), LogErrFatal ' DisableLogging

    ' Clean up a successful installation
 If (intExitCode <> GintRET_FINISHEDSUCCESS) Then
    'Setup has been aborted for one reason or another
    If (Len(sAppRemovalEXE) > 0) Then
        MsgBox "Setup must now remove temporary installation files.", 64, sSETUP
        Err.Clear
      
         Select Case intExitCode
                Case GintRET_FATAL
                    nErrorLevel = APPREMERR_FATAL
                Case GintRET_EXIT
                    nErrorLevel = APPREMERR_USERCANCEL
                Case GintRET_ABORT
                    nErrorLevel = APPREMERR_NONFATAL
                Case Else
                    nErrorLevel = APPREMERR_FATAL
          End Select

       Shell GetAppRemovalCmdLine(sAppRemovalEXE, sAppRemovalLog, nErrorLevel, True), vbNormalFocus
         If (Err.Number <> 0) Then
           sErr = Err.Description & vbCrLf & "Unable to remove temporary install files."
           MsgBox sErr, 64, sSETUP
         End If
    End If
  End If
  
    If frmBegin.Visible = True Then frmBegin.Hide
    If frmPath.Visible = True Then frmPath.Hide
     Unload frmPath
       Set frmPath = Nothing
     Unload fWelcome
       Set fWelcome = Nothing
     Unload frmBegin
       Set frmBegin = Nothing
     

    If intExitCode = GintRET_FINISHEDSUCCESS Then
        ExitProcess iSUCCESS
    Else
        ExitProcess iFAIL
    End If
End Sub
  

'-- modified Setup1 project:
'-- removed - CANNOT USE THESE ASPECTS:
    ' silent install functions removed.
    ' remote install functions removed.
    ' special treatment for data access components removed.
    ' does not write path value in registry for multiple apps.
       '-- (only used if setup.lst includes "AppPath" value in [Setup] section.)
    ' no ability to install from 2 or more drives.
    ' racmgr.exe, etc. functions removed.
    ' all program files must be in one CAB. (assumes not installing from floppy)
    
'-- startup with Mod1 Sub Main.
'-- Sub Main gets paths, loads forms, shows fwelcome.
'-- OK button on fWelcome runs ShowBeginInstall, which
   '-- shows frmBegin and puts apppath (tentative) in
   '-- frmBegin label.
'-- FrmBegin Change Location button opens frmPath.
    ' FrmPath deals with 2 things:
        ' getting progfol choice if program files folder not found.
        ' allowing choice of different install path.
'-- FrmBegin Install button runs ProceedInstall, which
'-- does the rest of the work:
  '--check for nec. space.
  ' copy files.
  ' register files.
  ' put link on start menu, desk, Q.L. (more link can be added with more calls to
  ' AddShortcuts)
  ' clean up.
  ' exit. If all is successful exit asks about adding desktop link.
