VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cShellLink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

'-- Shelllnk class - this is an edited version of the class
'-- that's on the VB CD in the Tools\Unsupported folder. -----------------------------
Private Const SHOWNORMAL As Long = 5
 

Public Function CreateShortcut(sLnkFile As String, sTargetPath As String, sTargetDesc As String, _
IconPath As String, IconIdx As Long) As Long
'-- sLnkFile is path for shortcut, ending in LNK
'-- sTargetPath is path of shortcut target
'-- sTargetDesc is description of target, such as filename
'-- IconPath is source of icon for shortcut, IconIdx is icon index.
'--to leave these out set iconpath as "" and iconidx as 0.
    Dim LNKOb As ShellLinkA                         ' An explorer IShellLinkA(Win 95/Win NT) instance
    Dim cPersistFile As IPersistFile                    ' An explorer IPersistFile instance
    CreateShortcut = 1 '--failed.
    If ((sLnkFile = "") Or (sTargetPath = "")) Then Exit Function    ' Validate min. input requirements.
    On Error GoTo ErrHandler
    Set LNKOb = New ShellLinkA                     ' Create new IShellLink interface
    Set cPersistFile = LNKOb                       ' Implement lnkob's IPersistFile interface
  
    With LNKOb
      .SetPath sTargetPath
      If (sTargetDesc <> "") Then .SetDescription sTargetDesc   ' Set shortcut description - basename
      If (IconPath <> "") Then .SetIconLocation IconPath, IconIdx ' Set shortcut icon location & index
      .SetShowCmd SHOWNORMAL        ' Set shortcut's startup mode (min,max,normal)
    End With
    
   LNKOb.Resolve 0, SLR_UPDATE
   cPersistFile.Save StrConv(sLnkFile, vbUnicode), 0    ' Unicode conversion hack... This must be done!
   CreateShortcut = 0                             ' Return Success
ErrHandler:

    Set cPersistFile = Nothing
    Set LNKOb = Nothing
End Function

